#include "MainSM.h"
#include "Mutex.h"


/* Task processing loop: waits for the signal to be postes and when it is ,
    loops to remove and process all events that are currently queued
*/

TSREventQueue_t * EVT_Queue = NULL;
TokenizerSyncSingleReceptor_t *StateDB;

/*
 * Initializes Event Queue stucture and State DatabseStructure.
 *
 * */
void TokenizerAsyncSingleReceptor_TurnOnEngine(void){
	/* Init StateDatabase and create its Mutex */
	StateDB = TokenizerAsyncSingleReceptor_Create();
	TokenizerSyncSingleReceptor_setItsMutex(StateDB, Mutex_create());
	/* Init Event Database and create its Mutex */
	EVT_Queue = TSREventQueue_Create();
	TSREventQueue_setItsMutex(EVT_Queue, Mutex_create());

	/* Initialize first event for state machine */
#ifdef USE_SIGNALS

    Event_t a;
    a.eType = EVT_Reset;
    TSREventQueue_post(EVT_Queue, a);
#endif
}

TokenizerSyncSingleReceptor_t *TokenizerAsyncSingleReceptor_Create(void){
	TokenizerSyncSingleReceptor_t *me = (TokenizerSyncSingleReceptor_t*)malloc(sizeof(TokenizerSyncSingleReceptor_t));
	if(me != NULL){
		TokenizerSyncSingleReceptor_Init(me);
	}else{
		while(1);
	}

	return me;
}

pHelperFunction_t HelperFunction;

void TokenizerAsyncSingleReceptor_taskLoop(void){
    while(1){
#ifdef USE_SIGNALS
    	waitOnSignal();/* Wait until signal occurs */
        while(!TSREventQueue_isEmpty(EVT_Queue)){
#endif
                TokenizerSyncSingleReceptor_eventDispatch(StateDB, TSREventQueue_pull(EVT_Queue));
                getValuesFromDevices(StateDB);
#ifdef USE_SIGNALS
                TSREventQueue_post(EVT_Queue, (Event_t){EVT_Measure,
                										StateDB->is_moving,
                										StateDB->is_paired,
                										StateDB->is_present});/* Signal event for future purposes*/
                }

#endif
    }
}

volatile bool_t TSRsignal;
void waitOnSignal(void){
bool_t loop = true;
	while(loop){
		if(TSRsignal){
			loop = false;
			TSRsignal = false;
		}
	}
}

void postSignal(void){
	TSRsignal = true;
}
