#ifndef TRSSYNCSINGLERECEPTOR_H_INCLUDED
#define TRSSYNCSINGLERECEPTOR_H_INCLUDED

#include "../SystemDefs.h"
#include "TokenizeAsyncSinglePKG.h"
#include "TSREventQueue.h"
#include "Mutex.h"

typedef struct sTokenizerSyncSingleReceptor{
	bool_t is_moving;
	bool_t is_present;
	bool_t is_paired;
    StateType_t stateID;
    SubStateType_t subStateID;
    mutex_t * itsMutex;
}TokenizerSyncSingleReceptor_t;

typedef struct evtState{
  void (*pOnEnter)(void);
  void (*pOnExit)(void);  
  int32_t (*pStateHandler)(TokenizerSyncSingleReceptor_t* pMsg);
}evtState_t;

typedef int32_t (*pHelperFunction_t)(TokenizerSyncSingleReceptor_t *pMsg);

void TokenizerSyncSingleReceptor_enter_GotNumber(TokenizerSyncSingleReceptor_t* const me);
void TokenizerSyncSingleReceptor_exit_GotNumber(TokenizerSyncSingleReceptor_t* const me);
void TokenizerSyncSingleReceptor_Init(TokenizerSyncSingleReceptor_t* const me);
void TokenizerSyncSingleReceptor_Cleanup_GotNumber(TokenizerSyncSingleReceptor_t* const me);

void TokenizerSyncSingleReceptor_eventDispatch(TokenizerSyncSingleReceptor_t* const me, Event_t e);
mutex_t* TokenizerSyncSingleReceptor_getItsMutex(const TokenizerSyncSingleReceptor_t* const me);
void TokenizerSyncSingleReceptor_setItsMutex(TokenizerSyncSingleReceptor_t* const me, mutex_t* pMutex);
TokenizerSyncSingleReceptor_t* TokenizerSyncSingleReceptor_Create(void);
void TokenizerSyncSingleReceptor_Destroy(TokenizerSyncSingleReceptor_t* const me);
void TokenizerSyncSingleReceptor_Cleanup(TokenizerSyncSingleReceptor_t* const me);
#endif // TRSSYNCSINGLERECEPTOR_H_INCLUDED
