#ifndef TSREVENTQUEUE_H_INCLUDED
#define TSREVENTQUEUE_H_INCLUDED

#include "TokenizeAsyncSinglePKG.h"
#include "Mutex.h"

//typedef struct TSREventQueue TSREventQueue;
typedef struct sTSREventQueue{
    Event_t q[10];
    int size;
    int head;
    int tail;
    mutex_t* itsMutex;
}TSREventQueue_t;

/*  Constructors and Destructors: */
void TSREventQueue_Init(TSREventQueue_t* const me);
void TSREventQueue_Cleanup(TSREventQueue_t* const me);

/* Operations */
// void TSREventQueue_isEmpty(TSREventQueue* const me); questo non dovrebbe essere void!
int TSREventQueue_isEmpty(TSREventQueue_t* const me); //questo non dovrebbe essere void!
int TSREventQueue_isFull(TSREventQueue_t* const me);
/*  Puts the passed event in the event queue and then calls the
    event receptor of the same state machine.
    Note if the queue overflow an error code (1) is returned. */
int TSREventQueue_post(TSREventQueue_t* const me, Event_t e);
/*  It is assumed that the caller has ensured that there is at least
    one event in the queue (via the isEmpty() function)
    prior to calling the function. Otherwise they get a default event. */

Event_t TSREventQueue_pull(TSREventQueue_t* const me);
void TSREventQueue_setItsMutex(TSREventQueue_t* const me, mutex_t * p_Mutex);
TSREventQueue_t *TSREventQueue_Create(void);
void TSREventQueue_Destroy(TSREventQueue_t * const me);
#endif // TSREVENTQUEUE_H_INCLUDED
