#ifndef TOKENIZE_ASYNC_SINGLE_PKG_H
#define TOKENIZE_ASYNC_SINGLE_PKG_H

#include "../SystemDefs.h"
#define QSIZE 10u

/* Enumerated type for the events */
typedef enum eEventType{
	EVT_Reset = 0,
	EVT_Measure,
    EVT_Total
}EventType_t;

/* Event: structure that contains an attribute to identifiy
    the type of the event and other data.
*/

typedef struct sEvent{
    EventType_t eType;
    struct eventData{
        uint32_t data1;
        uint32_t data2;
        uint32_t data3;
    }ed;
}Event_t;

typedef enum eStateType{
	STATE_POST = 0,
    STATE_INIT,
	STATE_CONF_MISS,
	STATE_START,
	STATE_DRIVING,
	STATE_HALT, /* Fermata  */
	STATE_STOP, /* Sosta	*/
    STATE_TOTAL
}StateType_t;

typedef enum eSubStateType{
    SUB_STATE_TOTAL = 0,
}SubStateType_t;
void postSignal(void);
void waitOnSignal(void);

#endif // TOKENIZE_ASYNC_SINGLE_PKG_H
