#include "src\StateMachine\single\TRSSyncSingleReceptor.h"
volatile bool HALT_TimerElapsed = false;
volatile uint32_t SecondsElapsed = 0; 
uint32_t HaltTimerTresh;

void SM_HALT_OnEnter(void){
  Serial.println("STATE: Halt_onEnter");
  SecondsElapsed = 0; 
  //HaltTimerTresh = 120;
  if(true== DYFAM_Timers.valid){
    HaltTimerTresh = DYFAM_Timers.HaltTimerTresh;
  }else{
    HaltTimerTresh = 120;
  }
  #ifdef ARDUNO
    TIM1_Elapsed = false; 
    TCNT1  = 0;//initialize counter value to 0
    TCCR1B |= (1 << WGM12);  // turn on CTC mode
    TIMSK1 |= (1 << OCIE1A);  // enable timer compare interrupt
  #else
    tcStartCounter(); //starts the timer
  #endif 
}

void SM_HALT_OnExit(void){
  Serial.println("Halt exit");
  //TimerStop();
  #ifdef ARDUNO
      TCCR1B &= ~(1 << WGM12);  // turn off CTC mode
  #else
    tcDisable(); //This function can be used anywhere if you need to stop/pause the timer
    //tcReset(); //This function should be called everytime you stop the timer
  #endif 
  }

int32_t SM_HALT(TokenizerSyncSingleReceptor_t *pMsg){
  Serial.println("STATE: Halt");
  if(pMsg->is_moving){
      pMsg->stateID = STATE_DRIVING; /* Fermata  */
  }else{
    pMsg->stateID = STATE_HALT;
  }
  if(TIM1_Elapsed){
    SecondsElapsed++;
    Serial.println(SecondsElapsed);
    TIM1_Elapsed = false; 
  }
  if(SecondsElapsed > HaltTimerTresh) HALT_TimerElapsed = true; 
  if(HALT_TimerElapsed ){
    pMsg->stateID = STATE_STOP;
  }
}
