#include "src\StateMachine\single\TRSSyncSingleReceptor.h"

void SM_INIT_OnEnter(void){
  Serial.println("STATE: Init_onEnter");
  while(!is_bluetooth_present());/* Wait for pairing */
}

void SM_INIT_OnExit(void){
  Serial.println("Init exit");
  }

int32_t SM_INIT(TokenizerSyncSingleReceptor_t *pMsg){
  Serial.println("STATE: Init");  
  mma.setRange(MMA8451_RANGE_8_G);
  Serial.print("Range = "); 
  Serial.print(2 << mma.getRange());  
  Serial.println("G");
  
  /*Init Timer1 Here */
  #ifdef ARDUNO
  //set timer1 interrupt at 1Hz
  TCCR1A = 0;// set entire TCCR1A register to 0
  TCCR1B = 0;// same for TCCR1B
  TCNT1  = 0;//initialize counter value to 0
  // set compare match register for 1hz increments
  OCR1A = 15624;// = (16*10^6) / (1*1024) - 1 (must be <65536)
  // turn on CTC mode
  //TCCR1B |= (1 << WGM12);
  // Set CS10 and CS12 bits for 1024 prescaler
  TCCR1B |= (1 << CS12) | (1 << CS10);  
  // enable timer compare interrupt
  //TIMSK1 |= (1 << OCIE1A);
  #else
    tcConfigure(1000); //configure the timer to run at <sampleRate>Hertz
  #endif 
  
  pMsg->stateID = STATE_START;
}

