#include "src\StateMachine\single\TRSSyncSingleReceptor.h"
bool STOP_TimerElapsed = false;
uint32_t STOP_TimerCounter;
uint32_t STOP_TimerCounter_tresh; 
uint32_t STOP_TimerTurnOff; 
uint32_t STOP_TimerTurnOff_tresh; 

typedef enum ealarmLevel {
  AlarmNone = 0, 
  AlarmL1, 
  AlarmL2, 
  AlarmL3,  
  AlarmTotal
}alarmLevel_t;

alarmLevel_t Alarm;

int32_t sendStringAndGetResponse(String str);

void SM_STOP_OnEnter(void){
  Serial.println("STATE: Stop_onEnter");
  TIM1_Elapsed = false; 
  STOP_TimerCounter = 0;
  if(true== DYFAM_Timers.valid){

    STOP_TimerCounter_tresh = DYFAM_Timers.STOP_TimerCounter_tresh;
    STOP_TimerTurnOff_tresh =  DYFAM_Timers.STOP_TimerTurnOff_tresh;
  }else{
    STOP_TimerCounter_tresh = 120;    
    STOP_TimerTurnOff_tresh = 10;
  }
  STOP_TimerTurnOff = 0;
  
  Alarm = AlarmNone;
  #ifdef ARDUNO
    TCNT1  = 0;//initialize counter value to 0
    TCCR1B |= (1 << WGM12);  // turn on CTC mode
    TIMSK1 |= (1 << OCIE1A);  // enable timer compare interrupt
  #else
    tcStartCounter(); //starts the timer
  #endif 
}

void SM_STOP_OnExit(void){
  Serial.println("Halt exit");
   tcDisable(); //This function can be used anywhere if you need to stop/pause the timer
   tcReset(); //This function should be called everytime you stop the timer
  }

/*
 * TODO: handle Disarm
*/
int32_t SM_STOP(TokenizerSyncSingleReceptor_t *pMsg){
   String message = "AlarmTotal";
  if(pMsg->is_present){
    if(TIM1_Elapsed){
      TIM1_Elapsed = false;
      STOP_TimerCounter++;
      if(STOP_TimerCounter> STOP_TimerCounter_tresh){
         STOP_TimerElapsed = true;
         STOP_TimerCounter = 0;
      }
    }
    if(STOP_TimerElapsed ){      
      switch(Alarm){
       case AlarmNone:
             Alarm = AlarmL1;
             Serial.println("AlarmL1");
             //SendNotification1
            break;
       
       case AlarmL1:
            Alarm = AlarmL2;
            Serial.println("AlarmL2");
            //SendNotification2
            break;
       
       case AlarmL2:
            Alarm = AlarmL3;
            Serial.println("AlarmL3");
            //SendNotification3
            break;
                   
       case AlarmL3:
            Alarm = AlarmTotal;
            Serial.println("AlarmTotal");
            message.trim();
            /* As long as the system fails, Keep trying send message */
            while(0 > sendStringAndGetResponse(message));
            break;           
            
       default:
            break;
      }
      STOP_TimerElapsed = false; 
    }
   pMsg->stateID = STATE_STOP;
  }else{
     if(TIM1_Elapsed){
      STOP_TimerTurnOff++;
      if(STOP_TimerTurnOff > STOP_TimerTurnOff_tresh);
      //TurnOff device, pin toggling here     
     }
  }
  
  /* Read data from bluetooth for handling disarm */
  /* E.G if(disarm){Alarm = AlarmNone;}*/
}

int32_t sendStringAndGetResponse(String str) {
  SigFox.beginPacket();
  SigFox.print(str);

  int32_t ret = SigFox.endPacket(true);  // send buffer to SIGFOX network and wait for a response
  if (ret > 0) {
    Serial.println("No transmission");
  } else {
    Serial.println("Transmission ok");
  }

  Serial.println(SigFox.status(SIGFOX));
  Serial.println(SigFox.status(ATMEL));

  if (SigFox.parsePacket()) {
    Serial.println("Response from server:");
    while (SigFox.available()) {
      Serial.print("0x");
      Serial.println(SigFox.read(), HEX);
    }
  } else {
    Serial.println("Could not get any response from the server");
  }
  Serial.println();
  SigFox.end();
  return ret;
}
